
REM     function defn : DEF FN a(A$,F$,b,c,d,e)=920
REM     to initialise : GO SUB 900
REM     to use        : GO SUB FN a(A$,F$,b,c,d,e)
REM     exit status   : Aerr (error status code +1 ; 0=OK)
REM     calls         : FN u(A$,H$,B,D)=USR DOS: B=bc=FN b(c,b): D=de=FN b(e,d)

REM	A$=action:      parameters:
     A=ABANDON      b=file#
     C=CLOSE        b=file#
   * D=SETDRIVE     f$=drive A-P, or Q=get default in f$
   + F=FREESPACE    f$=drive A-P, returns HL
   * G=GET1346      n/a, returns b,c,d,e as for SET1346
   + H=REFHEAD      b=file#, returns IX and h(8)
     I=INITIALISE   n/a
   + M=MEMORY CHECK b=line#, c=page, returns m(16,3) : page,start,end; fl reset on error
     O=OPEN         b=file#, f$=filename, c=access mode, d=create action, e=open action
   * R=READ         b=file#, c=page, de=address,
                    f$=string of length to read into f$,
                    or "=numeric_expression" length to read to address
     S=SET1346      b=1st DOS buffer, c=qty DOS buffers,
                    d=1st RAM buffer, e=qty RAM buffers
   * U=SETUSER      f$=user A-P, or Q=get default in f$
   * V=VERSION      n/a, returns d.e
     W=WRITE        b=file#, c=page, de=address,
                    f$=string of data to write from f$,
                    or "=numeric_expression" length to write from address
     a=SETACCESS    b=file#, c=access mode
   + e=GETEOF       b=file#, returns cde
     f=FLUSH        f$=drive A-P
   + g=GETPOSITION  b=file#, returns cde
     s=SETPOSITION  b=file#, cde=pointer

REM		OPEN
   	f$	= file name ($ff appended)
   	b	= b : file number * 256 + access mode
   		  c : access mode: 1=read, 2=write, 3=read/write, 5=shared read
   	d	= d : create action * 256 + open action
   			  create action (file does not exist):
   			  0=error, 1=create with header, 2=create without header
   		  e : open action (file exists):
   			  0=error, 1=open + read header + pointer=0,  2=open + ignore header + pointer=0
   			  3=erase f$.BAK + rename f$.xxx to f$.BAK + follow create action
   			  4=erase f$ + follow create action
REM		READ/WRITE
   	f$	= bytes: HL=address, DE=length
   	b	= b : file number * 256 + page number
   		  c : page number: 0-7
REM		SET1346
   	b   = d : 1st DOS buffer * 256 (0-127) + DOS buffer # (0-127)
   		  e :
   	d	= h : 1st RAM buffer * 256 (d+e) + RAM buffer # (0-(127-e))
   		  l :


REM 	CONSTANTS (global):
k0,k1,k2,k3,k4,k5,k6,k7,k8,kB,kC,kF,kG,k32,k7F,kFF,kFG,kM,k5M
k16k,k32k,k48k,k64k,DFA,DOS,drv,exe,m$,o$,p$
REM 	VARIABLES (global):
BC,DE,IX,HL
a,Aerr,Areg,bq,bqm,br,brm,bsm,cde,DAT,end,EOF,fl,inv,m0,m1,m2,p,z
g$,h(),m()
h...,i...,j...,o...
REM 	VARIABLES (local):
only those specified in the currently active function are visible
(ie. set by the last call to 915)
	FN a(A$,F$,b,c,d,e)
	FN u(A$,H$,b,d)
	FN g(q,r,p,a,z,g)


 899!LET DOS=32000+11: CLEAR DOS-12: STOP
 900!LET k0=NOT PI: LET k1=SGN PI: LET k2=k1+k1: LET k3=INT PI: LET k4=k3+k1:
    !LET k5=k4+k1: LET k6=k5+k1: LET k7=k6+k1: LET k8=k7+k1: LET k9=k8+k1: LET kB=k7+k4: LET kC=kB+k1:
     LET kF=k5*k3: LET kG=k4*k4: LET k32=kG*k2: LET k7F=127: LET kFF=255: LET kFG=kFF+k1
 901!LET kM=VAL "1000": LET k5M=k5*kM: LET k16k=VAL "16384": LET k32k=k16k*k2:
    !LET k48k=k16k*k3: LET k64k=k16k*k4: LET DFA=VAL "23563": LET DTA=VAL "23639":
    !LET DOS=VAL "32000+11"
 902 DEF FN a(A$,F$,b,c,d,e)=920
 903 DEF FN u(A$,H$,b,d)=USR DOS: REM BC returns A in B, DOS status in C
 904 DEF FN n(n,a,z)=INT ABS n AND n>=a AND n<=z: DEF FN c()=FN p(VAL "23621"):
     DEF FN p(a)=PEEK a+kFG*PEEK (a+k1): DEF FN b(l,h)=l+kFG*h:
     DEF FN l(v,d)=v-INT (v/d)*d: DEF FN d(o)=PEEK (DOS-o):
     DEF FN x(a,b)=a-(a-b AND a>b)
 905!IF FN p(DOS-kB)-(DOS-kB)<>VAL "410" THEN
    !  PRINT "Load CODE": LOAD "DOS_Demo" CODE DOS-kB,VAL "410"
 910!DIM h(kC): DIM m(kG,k3): LET m$="5201346": LET exe=VAL "1998": LET drv=VAL "1701":
     LET o$="IOCRWHGSVAFDUagsefM": LET p$=" OCRWH   A   agse  ":
     GO SUB FN a("M","-",k0,k0,k0,k0): RETURN

 915!LET DAT=FN p(DTA)+k8: POKE DFA+k1,k0: POKE DFA,FN l(DAT,kFG): POKE DFA+k1,INT (DAT/kFG): RETURN
 920!RESTORE 902: GO SUB 915: LET g$=F$: FOR o=k1 TO LEN o$: GOSUB kM+(100 AND A$=o$(o)): NEXT o
     REM Assign local B,C,D,E to global h(9,10,11,12)
 921!FOR h=k9 TO kC: LET h(h)=VAL VAL$ (""""+CHR$ (h+57)+""""): NEXT h
     REM disable DEFADD redirection before RETURN
 922!RESTORE FN c()+k1: POKE DFA+k1,k0
     REM Assign global h(9,10,11,12) global B,C,D,E
 923!FOR h=k9 TO kC: POKE FN p(DTA)+44,h+57: LET b=h(h): NEXT h: LET f$=g$: RETURN

     REM NoOp RETURN if a$ doesn't match in o$
1000 RETURN
     REM select action based on a$ match in o$
1100 LET de=k0: LET fl=k0: : IF o$(o)=p$(o) THEN LET b=FN n(b,k3,kF)
1102 GO TO kM+CODE o$(o)*10+(kM+kM AND o$(o)>="a")
1650 REM A=DOS_ABANDON
1651 GO TO exe
1670 REM C=DOS_CLOSE
1671 GO TO exe
1680 REM D=DOS_SETDRIVE (Q=get default)
1681 GO TO drv
1700 REM F=DOS_FREESPACE; also for SETDRIVE, SETUSER, FLUSH
1701 LET g$=CHR$ FN n(CODE g$,CODE "A",CODE "P"+(A$<>"f")): IF NOT CODE g$ THEN GO TO kM
1702 LET g$=((CHR$ (CODE g$-(65 AND A$="U")))AND g$<>"Q")+CHR$ kFF: GO TO exe
1710 REM G=DOS_GET1346
1711 GO TO exe
1720 REM H=DOS_REFHEAD
1721 GO TO exe
1730 REM I=DOS_INITIALISE
1731 GO TO exe
1770 REM M=MEMORY CHECK
1771 GO SUB k5M+b: RETURN
1790 REM O=DOS_OPEN: Access Mode: 1R/2W/3RW: Create Action: [0-2]: Open Action: [0-4]: File Name
1791 LET c=FN n(c,k1,k3): GO TO FN c()+c-(FN c()-kM AND NOT c)
1792 LET e=FN n(e,k0,k4): GO TO exe
1793 LET d=FN n(d,k0,k2): GO TO 1792
1794 GO TO 1793
1820 REM R=DOS_READ
1821 GO TO 1871
1830 REM S=DOS_SET1346 (1st DOS BCB always in Page 7 @ $e090)
1831 LET b=FN n(b,k0,k7F): LET c=FN n(c,k0,FN x(k7F-b,kF)): LET d=b+c
1832 LET e=FN n(e,k0,k7F-d): GO TO exe
1850 REM U=DOS_SETUSER (Q=get default)
1851 GO TO drv
1860 REM V=DOS_VERSION
1861 GO TO exe
1870 REM W=DOS_WRITE; also for READ: Page: Address: Data or Length
1871 LET c=FN n(c,k0,k7): LET de=FN b(e,d):
     LET fl=LEN g$: IF fl THEN IF g$(k1)="=" THEN LET fl=VAL g$(k2 TO)
1872 GO TO FN c()-(FN c()-kM AND NOT fl)+(k2 AND fl)+(A$="W" AND fl)
1873 GO SUB 5080: IF NOT fl THEN GO TO kM: REM Verify READ Address

2001!LET g$=g$+(CHR$ kFF AND A$="O")
2002 IF A$="R" OR A$="W" THEN LET d=INT(de/kFG): LET e=FN l(de,kFG)
2003 LET BC=FN u(A$,g$,FN b(c,b),FN b(e,d)):
     LET Areg=INT(BC/kFG): LET Aerr=FN l(BC,kFG):
     LET DE=FN p(DOS-k7): LET IX=FN p(DOS-k5): LET HL=FN p(DOS-k3):
     IF Aerr THEN PRINT "ERROR ";A$;":";Aerr-k1: STOP

2004 IF A$="D" OR A$="U" THEN LET g$=CHR$(Areg+(65 AND A$="U")): REM Default Drive/User
2005 IF A$="F" THEN LET g$=g$(k1): REM Free Space on Drive 'g$'='HL'kb
2006 IF A$="G" OR A$="S" OR A$="I" THEN LET BC=FN u("G","",k0,k0):
       LET b=FN d(k6): LET c=FN d(k7): LET d=FN d(k2): LET e=FN d(k3):
       GO SUB k5M+(80 AND A$="G"): REM 1st/Qty DOS buffers, 1st/Qty RAM buffers
2007!IF A$="H" THEN POKE 23388,kG+k7: FOR h=IX TO IX+k7: LET h(h-IX+k1)=PEEK h: NEXT h: REM file header at page 7 address IX
2008 IF A$="R" THEN LET HL=FN b(e,d): REM fl bytes read at page c address HL
       IF g$(k1)<>"=" THEN
         RESTORE 903: GO SUB 915: LET g$=H$: REM copy FN u(A$,H$,b,d) parameter H$
    !REM RESTORE 902: GO SUB 915: LET F$=g$: REM   to FN a(A$,F$,b,c,d,e) parameter F$
2009 IF A$="V" THEN LET d=FN d(k6): LET e=FN d(k7): REM DOS Version d.e
2010 IF A$="e" OR A$="g" THEN LET cde=FN d(k7)*k64k+HL: REM File pointer = cde
2029 RETURN

3970 REM a=DOS_SETACCESS
3971 LET c=FN n(c,k1,k3): GO TO exe-(exe-kM AND NOT c)
4010 REM e=DOS_GETEOF
4011 GO TO exe
4020 REM f=DOS_FLUSH
4021 GO TO drv
4030 REM g=DOS_GETPOSITION
4031 GO TO exe
4150 REM s=DOS_SETPOSITION
4151 LET BC=FN u("e","",FN b(c,b),k0): LET EOF=FN d(k7)*k64k+FN p(DOS-k3):
     LET cde=FN n(c*k64k+FN b(e,d),k0,EOF): LET de=FN l(cde,k64k)
4152!LET lv=VAL "23406": POKE lv,INT(cde/k64k): POKE lv+k1,INT(de/kFG): POKE lv+k2,FN l(de,kFG):
    !LET c=PEEK lv: LET d=PEEK (lv+k1): LET e=PEEK (lv+k2):
     GO TO exe: REM max=$ffffff

5000 DEF FN g(q,r,p,a,z,g)=g:
     REM Verify READ address does not conflict with:
     REM 1: BASIC program code & data
     REM 2: Machine & GO SUB stacks
     REM 3: Assembler program code & data
     REM 4: DOS/RAM buffer extents
     REM 5: DOS workspace in page 7
     REM Build a list of reserved areas
5002 LET m1=k1: RESTORE k5M: GO SUB 915
5010 GO SUB FN g(k16k,FN p(23653)+100,k0,k0,k0,5100)
5020 GO SUB FN g(FN p(23730)-100,FN p(23730),k0,k0,k0,5100)
5030 GO SUB FN g(DOS-kB,FN p(DOS-kB),k0,k0,k0,5100)
     REM bq=first buffer#, br=last buffer#, h=page sequence#, m$(h)=page#
     REM bqm=start address in page, brm=end address in page
5040 LET BC=FN u("G","",k0,k0): LET bq=FN d(k6): LET br=FN d(k6)+FN d(k7)+FN d(k3)-k1
5041 FOR h=INT (bq/k1G)+k4 TO INT (br/k1G)+k4:
       LET bqm=k48k+FN l(bq,k1G)*512: LET brm=k48k+FN l(br+k1,k1G)*512-k1:
       LET brm=brm-(brm-65535 AND (h<INT (br/k1G)+k4 OR brm<k48k)):
       GO SUB FN g(k0,k0,VAL m$(h),bqm,brm,5110): LET bq=k0:
     NEXT h
5050 GO SUB FN g(k0,k0,k7,k48k,49247,5110): GO SUB FN g(k0,k0,k7,56064,59391,5110)

5080 RESTORE 902: GO SUB 915: LET Aerr=30 AND fl: LET end=(de+fl-k1) AND A$="R": FOR j=k1 TO m1-k1:
       LET p=m(j,k1): LET a=m(j,k2): LET z=m(j,k3)
5082   LET inv=(c=p) AND (de>=a AND end<=z OR de<=a AND end>=a OR de<=z AND end>=z OR de<=a AND end>=z):
       LET fl=fl AND NOT inv
5083 NEXT j: LET Aerr=Aerr AND NOT fl: RETURN: REM leave Aerr set if fl reset

5100 FOR h=INT (q/k16k) TO INT (r/k16k): LET bsm=(h+k1)*k16k-k1:
       LET bqm=(h-k1)*k16k+q: LET brm=(h-k1)*k16k+r: LET brm=FN x(brm,bsm):
       GO SUB FN g(q,r,VAL m$(h),bqm,brm,5110): LET q=(h+k1)*k16k:
     NEXT h: RETURN

5110 LET m0=m1: LET m2=m1:
     FOR i=k2 TO k3: GO SUB 5120: LET a=z: LET m1=m0: NEXT i:
     LET m1=m2: RETURN

5120 GO SUB 5129
5121 IF p=k5 THEN LET a=a+(k32k AND a<k48k)-(k32k AND a>=k48k)
5122 IF p=k2 THEN LET a=a+(k16k AND a<k48k)-(k16k AND a>=k48k)
5123 IF p<>k5 AND p<>k2 THEN RETURN
5129 LET m(m1,k1)=p: LET m(m1,i)=a: LET m1=m1+k1: LET m2=m2+0.5: RETURN

5260 POKE 23658,k0: STOP: REM End of Program